#include <stdio.h>
#include <stdlib.h>
#include <io.h>

typedef struct {
	char	filename[_MAX_PATH];
	short	length;
} archiveInfo;

int main(int argc, char* argv[])
{
	if (argc < 2) {
		return 1;
	}
	
	FILE* ifp = fopen(argv[1], "rb");
	if (ifp == NULL) {
		return 1;
	}
	
	ftime itime;
	getftime(fileno(ifp), &itime);
	
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	_splitpath(argv[1], drive, dir, fname, ext);
	
	short num;
	fread(&num, 1, 2, ifp);
	
	archiveInfo* ai = new archiveInfo[num];
	
	short maxsize = 0;
	for (int i=0; i<num; ++i) {
		fread((void*)&ai[i].length, 1, 2, ifp);
		if (ai[i].length > maxsize) {
			maxsize = ai[i].length;
		}
		sprintf(ai[i].filename, "%s%s%s_%02d%s", drive, dir, fname, i+1, ext);
	}
	
	char* buf = new char[maxsize];
	FILE* ofp;
	
	for (int j=0; j<num; ++j) {
		fread(buf, 1, ai[j].length, ifp);
		ofp = fopen(ai[j].filename, "wb");
		fwrite(buf, 1, ai[j].length, ofp);
		setftime(fileno(ofp), &itime);
		fclose(ofp);
	}
	
	delete[] buf;
	delete[] ai;
	
	fclose(ifp);
	
	return 0;
}
